%global private_suffix 4-pcntl
%global private_php_dir %{_libdir}/%{name}

# Use the system PCRE library if it's at least as new as the bundled version
%global syspcre %(pkg-config --atleast-version=7.7 libpcre && echo "=%{_prefix}" || echo "")

Summary:	The PHP HTML-embedded scripting language, version 4, with process controls
Name:		php%{private_suffix}
Version:	4.4.9
Release:	3%{?dist}
URL:		http://www.php.net/
Source0:	http://www.php.net/distributions/php-%{version}.tar.gz
Patch0:		php-4.4.9-utf8.patch
Patch1:		php-4.4.9-system-pcre-lib64.patch
Patch2:		php-4.4.9-pcre_info.patch
License:	PHP
Group:		Development/Languages
Buildroot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	grep, flex, pcre-devel, pkgconfig

%description
PHP (Hypertext Preprocessor) is an HTML-embedded scripting language.
This minimal version is built with support for process controls and so
is not suitable for use in conjunction with a web server for security
reasons. This version is intended for use in building local
applications, possibly in conjunction with the php-gtk toolkit.

%package devel
Summary:	Files needed to build applications using %{name}
Group:		Development/Languages
Requires:	php%{private_suffix} = %{version}-%{release}

%description devel
Files needed to build applications using %{name}.

%prep
%setup -q -n php-%{version}

# Fix character encoding of documentation
%patch0 -p1

# Look for libpcre in lib64 too
%patch1 -p1

# Replace the long-deprecated pcre_info() with pcre_fullinfo()
%patch2 -p1

# Prevent %%doc confusion over LICENSE files
cp -p Zend/LICENSE Zend/ZEND_LICENSE
cp -p TSRM/LICENSE TSRM_LICENSE
cp -p regex/COPYRIGHT regex_COPYRIGHT

# Fix permissions in debuginfo package
find . -name '*.[ch]' | xargs chmod 644

%build
export CFLAGS="%{optflags}"
./configure --prefix=%{private_php_dir} \
	--libdir=%{private_php_dir}/lib \
	--disable-cgi \
	--disable-rpath \
	--disable-ipv6 \
	--disable-all \
	--enable-pcntl \
	--enable-posix \
	--disable-xml \
	--disable-safe-mode \
	--disable-sigchild \
	--disable-bcmath \
	--disable-calendar \
	--disable-ctype \
	--disable-dba \
	--disable-dbase \
	--disable-dbx \
	--disable-debug \
	--disable-dio \
	--disable-exit \
	--disable-filepro \
	--disable-ftp \
	--disable-gd-native-ttf \
	--disable-mbstring \
	--disable-mbregex \
	--disable-mime-magic \
	--disable-overload \
	--disable-session \
	--disable-shmop \
	--disable-ucd-snmp-hack \
	--disable-sockets \
	--disable-sysvmsg \
	--disable-sysvsem \
	--disable-sysvshm \
	--disable-wddx \
	--disable-xml \
	--disable-xslt \
	--disable-yp \
	--without-bz2 \
	--without-db3 \
	--without-curl \
	--without-gd \
	--without-ttf \
	--without-gdbm \
	--without-gettext \
	--without-ncurses \
	--without-gmp \
	--without-iconv \
	--without-jpeg \
	--without-mm \
	--without-openssl \
	--without-png \
	--without-pspell \
	--without-xml \
	--without-zlib \
	--without-imap \
	--without-kerberos \
	--without-ldap \
	--without-mysql \
	--without-pgsql \
	--without-snmp \
	--without-unixODBC \
	--without-mnogosearch \
	--with-pcre-regex%{syspcre}
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}{%{private_php_dir},%{_mandir}/man1,/bin}
make INSTALL_ROOT=%{buildroot} install
mv %{buildroot}%{private_php_dir}/man/man1/php.1 %{buildroot}%{_mandir}/man1/php%{private_suffix}.1
ln -s ..%{private_php_dir}/bin/php %{buildroot}/bin/php%{private_suffix}

# Compress manpages in non-standard location
gzip  %{buildroot}%{private_php_dir}/man/man*/php*

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
/bin/php%{private_suffix}
%dir %{private_php_dir}/
%dir %{private_php_dir}/bin/
%{private_php_dir}/bin/php
%{_mandir}/man1/php%{private_suffix}.1*
%doc CODING_STANDARDS CREDITS EXTENSIONS INSTALL LICENSE NEWS README*
%doc Zend/ZEND_* TSRM_LICENSE regex_COPYRIGHT

%files devel
%defattr(-,root,root,-)
%{private_php_dir}/bin/php-config
%{private_php_dir}/bin/phpize
%{private_php_dir}/lib/
%{private_php_dir}/include/
%dir %{private_php_dir}/man/
%dir %{private_php_dir}/man/man1/
%doc %{private_php_dir}/man/man1/php*.1*

%changelog
* Thu Mar  1 2012 Paul Howarth <paul@city-fan.org> 4.4.9-3
- use pcre_fullinfo() instead of the long-deprecated pcre_info(), for
  compatibility with pcre ≥ 8.30
- use a patch rather than scripted iconv to fix character encoding
- don't use macros for commands

* Mon Sep  7 2009 Paul Howarth <paul@city-fan.org> 4.4.9-2
- define RPM macros in global scope
- use system PCRE library where it's at least as new as the bundled version

* Fri Aug  8 2008 Paul Howarth <paul@city-fan.org> 4.4.9-1
- update to 4.4.9

* Fri Jan  4 2008 Paul Howarth <paul@city-fan.org> 4.4.8-1
- update to 4.4.8
- tweak license tag to silence rpmlint
- replace /bin/php4-pcntl a relative symlink rather than an absolute one
- documentation converted to UTF-8
- manpages marked as %%doc and compressed

* Wed Apr 12 2006 Paul Howarth <paul@city-fan.org> 4.4.1-2
- rename package to php4-pcntl to avoid install-time removal of the main php
  package in distributions whose main php package provides php-pcntl, such as
  Fedora Core 5
- define %%__id_u macro in a more portable way
- add %%{?dist} tag for distribution-specific build identification
- bogus dependency filter no longer seems to be needed
- honour %%{optflags}
- specify libdir for configure (pacify rpmlint a bit)

* Sat Nov  5 2005 Paul Howarth <paul@city-fan.org> 4.4.1-1
- update to 4.4.1
- remove buildroot unconditionally in %%clean and %%install

* Mon Jul 18 2005 Paul Howarth <paul@city-fan.org> 4.4.0-1
- update to 4.4.0
- make sure all directories are owned properly
- autotools patch no longer needed
- phpextdist no longer included
- include manpages for phpize and php-config

* Mon Apr 11 2005 Paul Howarth <paul@city-fan.org> 4.3.11-1
- update to 4.3.11
- revise automake patch, now partly incorporated upstream

* Tue Mar 22 2005 Paul Howarth <paul@city-fan.org> 4.3.10-3
- add flex as build requirement

* Tue Mar 22 2005 Paul Howarth <paul@city-fan.org> 4.3.10-2
- add kludge to enable build with rpm-build < 4.2, removing bogus
  dependencies from -devel subpackage
- remove dependency on smtpdaemon

* Wed Dec 22 2004 Paul Howarth <paul@city-fan.org> 4.3.10-1
- update to 4.3.10

* Thu Sep 30 2004 Paul Howarth <paul@city-fan.org> 4.3.9-2
- add symlink /bin/php-pcntl -> %%{private_php_dir}/bin/php for
  architecure-independent way of finding php-pcntl

* Sun Sep 26 2004 Paul Howarth <paul@city-fan.org> 4.3.9-1
- update to 4.3.9

* Tue Jul 20 2004 Paul Howarth <paul@city-fan.org> 4.3.8-1
- update to 4.3.8

* Sat Jun 19 2004 James Cameron <james.cameron@hp.com>
- rpm build on debian

* Tue Jun 15 2004 Paul Howarth <paul@city-fan.org>
- initial RPM build
